<?php
/**
 * Created by JetBrains PhpStorm.
 * User: geovanesantos
 * Date: 08/04/14
 * Time: 15:42
 * To change this template use File | Settings | File Templates.
 */

namespace Scheduler\Facade;
use Scheduler\Logic;
require_once __DIR__ . '/../Util/Macros.php';
//require_once  __DIR__.'/../Util/ParamWindowFunctions.php';

use Setforms2\Runtime\ContextVars;

/**
 * Class ParamBuilder
 *  Facade responsável por pegar os dados da tela de parâmetros e colocá-los na tela principal
 * @package Scheduler\Facade
 */
class ParamBuilder{

    /**
     * Transforma os dados preenchidos nos campos ativos em um JSON que será lido pelo processo
     */
    public static function criaJson(){
        $fieldArray=tk_get_all_fields(); //pega todos os campos

        unset($fieldArray['_ID']);
        unset($fieldArray['_STATE']);
        unset($fieldArray['_CHECKED']);

        $paramArray=self::makeParamArray($fieldArray); //faz um array com as coisas necessárias p/ processo
        //trocando &quot por um placeholder, para escapar depois(vira uma " em htmlspecialchars_decode, lá na frente)
        $paramArray=str_replace("&quot;", '%ASPAS%', $paramArray);
        $paramJson=json_encode($paramArray);
        //só escapar agora, pois json_encode escapa o próprio \ de escape
        $paramJson=str_replace("%ASPAS%", '\&quot;', $paramJson);
        tk_set_context_vars("PROCESS_PARAMS", "scd_execprocesso_usuario",$paramJson);
        tk_close_window("scd_popup_params", true);
    }

    /**
     * Gera o array de parâmetros que será transformado em um json, preparando o array de dados cru, lidando com
     * o campo "PARAMETROS", e adicionando os parâmetros pré-atribuídos no tipo de processo.
     *
     * @param $fieldData
     *  O array de parâmetros que será manipulado. É o output puro de um tk_get_all_fields
     * @return array
     */
    public static function makeParamArray($fieldData){
        $paramArray=Array();
        $activeFields=tk_get_env_var("ACTIVE_FIELDS");    //só os campos ativos serão
        $arrayAttribs=tk_get_env_var("ATTRIBUTED_PARAMETERS");     //parâmetros atribuídos no próprio tipo de processo
        foreach($activeFields as $field) {
            $paramArray[$field]=$fieldData[$field][""];
        }

        if (isset($paramArray["PARAMETERS"])){

            $arrayProcedureParams=\Scheduler\Facade\ParamBuilder::arrayifyParameterField($paramArray["PARAMETERS"]);
            $paramArray=array_merge($paramArray,$arrayProcedureParams);
            unset($paramArray["PARAMETERS"]);
        }

        //$paramArray["NRORG"]=\Geral\Util\Ambiente::getNrorgTrabalho();

        foreach($arrayAttribs as $fieldkey=>$fieldvalue) {
            $paramArray[$fieldkey]=$fieldvalue;
        }

        return $paramArray;
    }

    //TODO: Colocar isso no Util
    /**
     * Recebe uma string com uma série de atribuições(com o sinal =) separadas por \n e transforma-as num array,
     * [propiedade]=valor.
     *
     * @param $parameters
     * @return array
     */
    public static function arrayifyParameterField($parameters){
        $arrayParameters=explode("\n", $parameters);
        $arrayResponse=Array();

        if(!empty($arrayParameters[0])){
            foreach ($arrayParameters as $param){

                $attrib=explode("=", $param);
                //$procedureToCheck=tk_get_field_value("PROCEDURE_NAME");
                //$currentProcedureParams=\Scheduler\Util\ProcedureParameterFunctions::getProcedureParamsAsArray($procedureToCheck);

                //if($currentProcedureParams[$attrib[0]]===2) $attrib[1]="'".$attrib[1]."'";

                $arrayResponse[$attrib[0]]=$attrib[1];
            }
        }
        return $arrayResponse;
    }

}