/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_SERV                                                     */
/* Tabela : SERVICO                                                           */
/*                                                                            */
/* Criao:                                                                   */
/* 18/06/2001 - Newton Neves dos Santos                                       */
/*                                                                            */
/******************************************************************************/


CREATE OR REPLACE TRIGGER DTULTATU_SERV
BEFORE INSERT OR UPDATE OR DELETE
ON SERVICO FOR EACH ROW
BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUSERV := SYSDATE;
   END IF;
   IF UPDATING THEN
      IF (NVL(:OLD.CDFILIAL,      '') <> NVL(:NEW.CDFILIAL,      '')) OR
         (NVL(:OLD.CDSERVFILI,    '') <> NVL(:NEW.CDSERVFILI,    '')) OR
         (NVL(:OLD.NMSERVICO,     '') <> NVL(:NEW.NMSERVICO,     '')) OR
         (NVL(:OLD.QTCOMESTIDOM,   -1) <> NVL(:NEW.QTCOMESTIDOM,   -1)) OR
         (NVL(:OLD.QTCLIESTIDOM,   -1) <> NVL(:NEW.QTCLIESTIDOM,   -1)) OR
         (NVL(:OLD.QTFUNESTIDOM,   -1) <> NVL(:NEW.QTFUNESTIDOM,   -1)) OR
         (NVL(:OLD.QTDOAESTIDOM,   -1) <> NVL(:NEW.QTDOAESTIDOM,   -1)) OR
         (NVL(:OLD.QTCOMESTISEG,   -1) <> NVL(:NEW.QTCOMESTISEG,   -1)) OR
         (NVL(:OLD.QTCLIESTISEG,   -1) <> NVL(:NEW.QTCLIESTISEG,   -1)) OR
         (NVL(:OLD.QTFUNESTISEG,   -1) <> NVL(:NEW.QTFUNESTISEG,   -1)) OR
         (NVL(:OLD.QTDOAESTISEG,   -1) <> NVL(:NEW.QTDOAESTISEG,   -1)) OR
         (NVL(:OLD.QTCOMESTITER,   -1) <> NVL(:NEW.QTCOMESTITER,   -1)) OR
         (NVL(:OLD.QTCLIESTITER,   -1) <> NVL(:NEW.QTCLIESTITER,   -1)) OR
         (NVL(:OLD.QTFUNESTITER,   -1) <> NVL(:NEW.QTFUNESTITER,   -1)) OR
         (NVL(:OLD.QTDOAESTITER,   -1) <> NVL(:NEW.QTDOAESTITER,   -1)) OR
         (NVL(:OLD.QTCOMESTIQUA,   -1) <> NVL(:NEW.QTCOMESTIQUA,   -1)) OR
         (NVL(:OLD.QTCLIESTIQUA,   -1) <> NVL(:NEW.QTCLIESTIQUA,   -1)) OR
         (NVL(:OLD.QTFUNESTIQUA,   -1) <> NVL(:NEW.QTFUNESTIQUA,   -1)) OR
         (NVL(:OLD.QTDOAESTIQUA,   -1) <> NVL(:NEW.QTDOAESTIQUA,   -1)) OR
         (NVL(:OLD.QTCOMESTIQUI,   -1) <> NVL(:NEW.QTCOMESTIQUI,   -1)) OR
         (NVL(:OLD.QTCLIESTIQUI,   -1) <> NVL(:NEW.QTCLIESTIQUI,   -1)) OR
         (NVL(:OLD.QTFUNESTIQUI,   -1) <> NVL(:NEW.QTFUNESTIQUI,   -1)) OR
         (NVL(:OLD.QTDOAESTIQUI,   -1) <> NVL(:NEW.QTDOAESTIQUI,   -1)) OR
         (NVL(:OLD.QTCOMESTISEX,   -1) <> NVL(:NEW.QTCOMESTISEX,   -1)) OR
         (NVL(:OLD.QTCLIESTISEX,   -1) <> NVL(:NEW.QTCLIESTISEX,   -1)) OR
         (NVL(:OLD.QTFUNESTISEX,   -1) <> NVL(:NEW.QTFUNESTISEX,   -1)) OR
         (NVL(:OLD.QTDOAESTISEX,   -1) <> NVL(:NEW.QTDOAESTISEX,   -1)) OR
         (NVL(:OLD.QTCOMESTISAB,   -1) <> NVL(:NEW.QTCOMESTISAB,   -1)) OR
         (NVL(:OLD.QTCLIESTISAB,   -1) <> NVL(:NEW.QTCLIESTISAB,   -1)) OR
         (NVL(:OLD.QTFUNESTISAB,   -1) <> NVL(:NEW.QTFUNESTISAB,   -1)) OR
         (NVL(:OLD.QTDOAESTISAB,   -1) <> NVL(:NEW.QTDOAESTISAB,   -1)) OR
         (NVL(:OLD.QTCOMESTIFER,   -1) <> NVL(:NEW.QTCOMESTIFER,   -1)) OR
         (NVL(:OLD.QTCLIESTIFER,   -1) <> NVL(:NEW.QTCLIESTIFER,   -1)) OR
         (NVL(:OLD.QTFUNESTIFER,   -1) <> NVL(:NEW.QTFUNESTIFER,   -1)) OR
         (NVL(:OLD.QTDOAESTIFER,   -1) <> NVL(:NEW.QTDOAESTIFER,   -1)) OR
         (NVL(:OLD.HRINICATEN,    '') <> NVL(:NEW.HRINICATEN,    '')) OR
         (NVL(:OLD.IDTPSERVHOSP,  '') <> NVL(:NEW.IDTPSERVHOSP,  '')) OR
         (NVL(:OLD.IDSERVPADR,    '') <> NVL(:NEW.IDSERVPADR,    '')) OR
         (NVL(:OLD.CDGRUPSERV,    '') <> NVL(:NEW.CDGRUPSERV,    '')) OR
         (NVL(:OLD.IDTIPOSERV,    '') <> NVL(:NEW.IDTIPOSERV,    '')) OR
         (NVL(:OLD.IDSERVTRAN,    '') <> NVL(:NEW.IDSERVTRAN,    '')) OR
         (NVL(:OLD.CDROTATRANS,   '') <> NVL(:NEW.CDROTATRANS,   '')) OR
         (NVL(:OLD.IDCONSSERVCA,  '') <> NVL(:NEW.IDCONSSERVCA,  '')) OR
         (NVL(:OLD.IDSERVATIV,    '') <> NVL(:NEW.IDSERVATIV,    '')) OR
         (NVL(:OLD.CDPRODUTO,     '') <> NVL(:NEW.CDPRODUTO,     '')) OR
         (NVL(:OLD.IDUTRETIPRAT,  '') <> NVL(:NEW.IDUTRETIPRAT,  '')) OR
         (NVL(:OLD.IDCARDDESCENTR,'') <> NVL(:NEW.IDCARDDESCENTR,'')) THEN
         :NEW.DTULTATUSERV := SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('SERVICO', :OLD.CDFILIAL, 'CDFILIAL='||:OLD.CDFILIAL||';CDSERVFILI='||:OLD.CDSERVFILI||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE SERVICO MODIFY DTULTATUSERV DEFAULT SYSDATE
/

-- VERSAO --
BEGIN ATUVEROBJ('DTULTATU_SERV','4.11.169'); END;
/

