/* Tabela NOTADESTINADA: Notas contra o CNPJ */
/* Descrio: A trigger insere registros na tabela LOGOPERA a partir de alteraes na tabela NOTADESTINADA */
/* Objetivo: Gerar um log que vai registrar as alteraes na tabela NOTADESTINADA,
             utilizando a tabela Geral de Logs de Operaes */
IF EXISTS(SELECT * FROM SYSOBJECTS O, SYSUSERS U
          WHERE O.NAME = 'LOG_FIS_NOTADESTINADA' AND
                TYPE   = 'TR'              AND
                U.UID  = O.UID             AND
                U.NAME = USER)

DROP TRIGGER LOG_FIS_NOTADESTINADA
GO

CREATE TRIGGER LOG_FIS_NOTADESTINADA
ON NOTADESTINADA
FOR UPDATE,INSERT, DELETE
AS

  DECLARE @V_USUARIO      VARCHAR(40);
  DECLARE @V_TIPO         VARCHAR(1);
  DECLARE @V_ITPESQ       VARCHAR(40);
  DECLARE @V_DESC         VARCHAR(4000);
  DECLARE @V_DTOPER       DATETIME;
  DECLARE @V_IDTIPO           VARCHAR(1);

  /*VARIVEIS DO CURSOR C_CURSORND*/
  DECLARE @V_ID_COMANDO      VARCHAR(1);
  DECLARE @V_NRNFDESTINADA_OLD NUMERIC;
  DECLARE @V_CDINSCESTA_OLD VARCHAR(16);
  DECLARE @V_SGESTADO_OLD VARCHAR(02);
  DECLARE @V_NRNSU_OLD VARCHAR(15);
  DECLARE @V_NRACESSONFE_OLD VARCHAR(50);
  DECLARE @V_NRINSJUREMIT_OLD VARCHAR(20);
  DECLARE @V_NMRAZSOCEMIT_OLD VARCHAR(250);
  DECLARE @V_CDINSCESTAEMIT_OLD VARCHAR(16);
  DECLARE @V_DTEMISSAO_OLD DATETIME;
  DECLARE @V_NRNOTAFISC_OLD VARCHAR(20);
  DECLARE @V_IDENTRSAIDNF_OLD VARCHAR(01);
  DECLARE @V_VRNOTAFISC_OLD DOUBLE PRECISION;
  DECLARE @V_CDDIGESTVALUE_OLD VARCHAR(50);
  DECLARE @V_DTRECBTO_OLD DATETIME;
  DECLARE @V_IDSTATUSNFE_OLD VARCHAR(01);
  DECLARE @V_IDSTATUSMANIF_OLD VARCHAR(01);
  DECLARE @V_IDTIPOEVENTO_OLD VARCHAR(01);
  DECLARE @V_DTHREVENTO_OLD DATETIME;
  DECLARE @V_NRSEQEVENTO_OLD VARCHAR(02);
  DECLARE @V_DSCORRECAONFE_OLD VARCHAR(1000);
  DECLARE @V_CDFILIAL_OLD VARCHAR(04);
  DECLARE @V_NRLANCTONF_OLD VARCHAR(10);
  DECLARE @V_NRACESSOINTG_OLD VARCHAR(50);
  DECLARE @V_IDAMBIENTEMANIF_OLD VARCHAR(01);
  DECLARE @V_DSOBSSTATUSMANIF_OLD VARCHAR(250);
  DECLARE @V_NRLOTEMANIF_OLD VARCHAR(15);
  DECLARE @V_NRPROTOCOLO_OLD VARCHAR(15);
  DECLARE @V_CDIBGEESTADOA_OLD VARCHAR(02);
  DECLARE @V_IDASSINATURA_OLD VARCHAR(17);
  DECLARE @V_NRDOWNLOADXML_OLD INTEGER;
  DECLARE @V_NRNFDESTINADA_NEW NUMERIC;
  DECLARE @V_CDINSCESTA_NEW VARCHAR(16);
  DECLARE @V_SGESTADO_NEW VARCHAR(02);
  DECLARE @V_NRNSU_NEW VARCHAR(15);
  DECLARE @V_NRACESSONFE_NEW VARCHAR(50);
  DECLARE @V_NRINSJUREMIT_NEW VARCHAR(20);
  DECLARE @V_NMRAZSOCEMIT_NEW VARCHAR(250);
  DECLARE @V_CDINSCESTAEMIT_NEW VARCHAR(16);
  DECLARE @V_DTEMISSAO_NEW DATETIME;
  DECLARE @V_NRNOTAFISC_NEW VARCHAR(20);
  DECLARE @V_IDENTRSAIDNF_NEW VARCHAR(01);
  DECLARE @V_VRNOTAFISC_NEW DOUBLE PRECISION;
  DECLARE @V_CDDIGESTVALUE_NEW VARCHAR(50);
  DECLARE @V_DTRECBTO_NEW DATETIME;
  DECLARE @V_IDSTATUSNFE_NEW VARCHAR(01);
  DECLARE @V_IDSTATUSMANIF_NEW VARCHAR(01);
  DECLARE @V_IDTIPOEVENTO_NEW VARCHAR(01);
  DECLARE @V_DTHREVENTO_NEW DATETIME;
  DECLARE @V_NRSEQEVENTO_NEW VARCHAR(02);
  DECLARE @V_DSCORRECAONFE_NEW VARCHAR(1000);
  DECLARE @V_CDFILIAL_NEW VARCHAR(04);
  DECLARE @V_NRLANCTONF_NEW VARCHAR(10);
  DECLARE @V_NRACESSOINTG_NEW VARCHAR(50);
  DECLARE @V_IDAMBIENTEMANIF_NEW VARCHAR(01);
  DECLARE @V_DSOBSSTATUSMANIF_NEW VARCHAR(250);
  DECLARE @V_NRLOTEMANIF_NEW VARCHAR(15);
  DECLARE @V_NRPROTOCOLO_NEW VARCHAR(15);
  DECLARE @V_CDIBGEESTADOA_NEW VARCHAR(02);
  DECLARE @V_IDASSINATURA_NEW VARCHAR(17);
  DECLARE @V_NRDOWNLOADXML_NEW INTEGER;
  DECLARE @V_TAM INTEGER;

BEGIN
   SET @V_TIPO = '0';
   SET @V_DESC = '';
   EXEC NMUSUARIO @V_USUARIO;
   SET @V_USUARIO = ISNULL(@V_USUARIO,' ' );

   DECLARE C_CURSOR_ND CURSOR FOR
      SELECT
         'D' IDCOMANDO,
         NRNFDESTINADA,    CDINSCESTA,      SGESTADO,
         NRNSU,            NRACESSONFE,     NRINSJUREMIT,
         NMRAZSOCEMIT,     CDINSCESTAEMIT,  DTEMISSAO,
         NRNOTAFISC,       IDENTRSAIDNF,    VRNOTAFISC,
         CDDIGESTVALUE,    DTRECBTO,        IDSTATUSNFE,
         IDSTATUSMANIF,    IDTIPOEVENTO,    DTHREVENTO,
         NRSEQEVENTO,      DSCORRECAONFE,   CDFILIAL,
         NRLANCTONF,       NRACESSOINTG,    IDAMBIENTEMANIF,
         DSOBSSTATUSMANIF, NRLOTEMANIF,     NRPROTOCOLO,
         CDIBGEESTADOA,    IDASSINATURA,    NRDOWNLOADXML,

         NULL, NULL, NULL,
         NULL, NULL, NULL,
         NULL, NULL, NULL,
         NULL, NULL, NULL,
         NULL, NULL, NULL,
         NULL, NULL, NULL,
         NULL, NULL, NULL,
         NULL, NULL, NULL,
         NULL, NULL, NULL,
         NULL, NULL, NULL

      FROM
         DELETED
      WHERE
         NRNFDESTINADA NOT IN (SELECT NRNFDESTINADA FROM INSERTED)

      UNION ALL

      SELECT
         'U' IDCOMANDO,
         DELETED.NRNFDESTINADA,    DELETED.CDINSCESTA,      DELETED.SGESTADO,
         DELETED.NRNSU,            DELETED.NRACESSONFE,     DELETED.NRINSJUREMIT,
         DELETED.NMRAZSOCEMIT,     DELETED.CDINSCESTAEMIT,  DELETED.DTEMISSAO,
         DELETED.NRNOTAFISC,       DELETED.IDENTRSAIDNF,    DELETED.VRNOTAFISC,
         DELETED.CDDIGESTVALUE,    DELETED.DTRECBTO,        DELETED.IDSTATUSNFE,
         DELETED.IDSTATUSMANIF,    DELETED.IDTIPOEVENTO,    DELETED.DTHREVENTO,
         DELETED.NRSEQEVENTO,      DELETED.DSCORRECAONFE,   DELETED.CDFILIAL,
         DELETED.NRLANCTONF,       DELETED.NRACESSOINTG,    DELETED.IDAMBIENTEMANIF,
         DELETED.DSOBSSTATUSMANIF, DELETED.NRLOTEMANIF,     DELETED.NRPROTOCOLO,
         DELETED.CDIBGEESTADOA,    DELETED.IDASSINATURA,    DELETED.NRDOWNLOADXML,

         INSERTED.NRNFDESTINADA,    INSERTED.CDINSCESTA,     INSERTED.SGESTADO,
         INSERTED.NRNSU,            INSERTED.NRACESSONFE,    INSERTED.NRINSJUREMIT,
         INSERTED.NMRAZSOCEMIT,     INSERTED.CDINSCESTAEMIT, INSERTED.DTEMISSAO,
         INSERTED.NRNOTAFISC,       INSERTED.IDENTRSAIDNF,   INSERTED.VRNOTAFISC,
         INSERTED.CDDIGESTVALUE,    INSERTED.DTRECBTO,       INSERTED.IDSTATUSNFE,
         INSERTED.IDSTATUSMANIF,    INSERTED.IDTIPOEVENTO,   INSERTED.DTHREVENTO,
         INSERTED.NRSEQEVENTO,      INSERTED.DSCORRECAONFE,  INSERTED.CDFILIAL,
         INSERTED.NRLANCTONF,       INSERTED.NRACESSOINTG,   INSERTED.IDAMBIENTEMANIF,
         INSERTED.DSOBSSTATUSMANIF, INSERTED.NRLOTEMANIF,    INSERTED.NRPROTOCOLO,
         INSERTED.CDIBGEESTADOA,    INSERTED.IDASSINATURA,   INSERTED.NRDOWNLOADXML
      FROM
         INSERTED,
         DELETED
      WHERE
         INSERTED.NRNFDESTINADA    = DELETED.NRNFDESTINADA

      UNION ALL

      SELECT
         'I' IDCOMANDO,
         NULL, NULL, NULL,
         NULL, NULL, NULL,
         NULL, NULL, NULL,
         NULL, NULL, NULL,
         NULL, NULL, NULL,
         NULL, NULL, NULL,
         NULL, NULL, NULL,
         NULL, NULL, NULL,
         NULL, NULL, NULL,
         NULL, NULL, NULL,

         INSERTED.NRNFDESTINADA,    INSERTED.CDINSCESTA,     INSERTED.SGESTADO,
         INSERTED.NRNSU,            INSERTED.NRACESSONFE,    INSERTED.NRINSJUREMIT,
         INSERTED.NMRAZSOCEMIT,     INSERTED.CDINSCESTAEMIT, INSERTED.DTEMISSAO,
         INSERTED.NRNOTAFISC,       INSERTED.IDENTRSAIDNF,   INSERTED.VRNOTAFISC,
         INSERTED.CDDIGESTVALUE,    INSERTED.DTRECBTO,       INSERTED.IDSTATUSNFE,
         INSERTED.IDSTATUSMANIF,    INSERTED.IDTIPOEVENTO,   INSERTED.DTHREVENTO,
         INSERTED.NRSEQEVENTO,      INSERTED.DSCORRECAONFE,  INSERTED.CDFILIAL,
         INSERTED.NRLANCTONF,       INSERTED.NRACESSOINTG,   INSERTED.IDAMBIENTEMANIF,
         INSERTED.DSOBSSTATUSMANIF, INSERTED.NRLOTEMANIF,    INSERTED.NRPROTOCOLO,
         INSERTED.CDIBGEESTADOA,    INSERTED.IDASSINATURA,   INSERTED.NRDOWNLOADXML

      FROM
         INSERTED
      WHERE
         NRNFDESTINADA NOT IN (SELECT NRNFDESTINADA FROM DELETED);

   OPEN C_CURSOR_ND;
   FETCH NEXT FROM C_CURSOR_ND INTO @V_ID_COMANDO,
                                    @V_NRNFDESTINADA_OLD,    @V_CDINSCESTA_OLD,      @V_SGESTADO_OLD,
                                    @V_NRNSU_OLD,            @V_NRACESSONFE_OLD,     @V_NRINSJUREMIT_OLD,
                                    @V_NMRAZSOCEMIT_OLD,     @V_CDINSCESTAEMIT_OLD,  @V_DTEMISSAO_OLD,
                                    @V_NRNOTAFISC_OLD,       @V_IDENTRSAIDNF_OLD,    @V_VRNOTAFISC_OLD,
                                    @V_CDDIGESTVALUE_OLD,    @V_DTRECBTO_OLD,        @V_IDSTATUSNFE_OLD,
                                    @V_IDSTATUSMANIF_OLD,    @V_IDTIPOEVENTO_OLD,    @V_DTHREVENTO_OLD,
                                    @V_NRSEQEVENTO_OLD,      @V_DSCORRECAONFE_OLD,   @V_CDFILIAL_OLD,
                                    @V_NRLANCTONF_OLD,       @V_NRACESSOINTG_OLD,    @V_IDAMBIENTEMANIF_OLD,
                                    @V_DSOBSSTATUSMANIF_OLD, @V_NRLOTEMANIF_OLD,     @V_NRPROTOCOLO_OLD,
                                    @V_CDIBGEESTADOA_OLD,    @V_IDASSINATURA_OLD,    @V_NRDOWNLOADXML_OLD,

                                    @V_NRNFDESTINADA_NEW,    @V_CDINSCESTA_NEW,     @V_SGESTADO_NEW,
                                    @V_NRNSU_NEW,            @V_NRACESSONFE_NEW,    @V_NRINSJUREMIT_NEW,
                                    @V_NMRAZSOCEMIT_NEW,     @V_CDINSCESTAEMIT_NEW, @V_DTEMISSAO_NEW,
                                    @V_NRNOTAFISC_NEW,       @V_IDENTRSAIDNF_NEW,   @V_VRNOTAFISC_NEW,
                                    @V_CDDIGESTVALUE_NEW,    @V_DTRECBTO_NEW,       @V_IDSTATUSNFE_NEW,
                                    @V_IDSTATUSMANIF_NEW,    @V_IDTIPOEVENTO_NEW,   @V_DTHREVENTO_NEW,
                                    @V_NRSEQEVENTO_NEW,      @V_DSCORRECAONFE_NEW,  @V_CDFILIAL_NEW,
                                    @V_NRLANCTONF_NEW,       @V_NRACESSOINTG_NEW,   @V_IDAMBIENTEMANIF_NEW,
                                    @V_DSOBSSTATUSMANIF_NEW, @V_NRLOTEMANIF_NEW,    @V_NRPROTOCOLO_NEW,
                                    @V_CDIBGEESTADOA_NEW,    @V_IDASSINATURA_NEW,   @V_NRDOWNLOADXML_NEW;


   WHILE (@@FETCH_STATUS = 0) BEGIN

      IF @V_ID_COMANDO = 'D' BEGIN
         SET @V_TIPO = '3';
         SET @V_ITPESQ = @V_NRNFDESTINADA_OLD;

         IF @V_CDINSCESTA_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' IE=' + @V_CDINSCESTA_OLD;
         END;

         IF @V_SGESTADO_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' UF=' + @V_SGESTADO_OLD;
         END;

         IF @V_NRNSU_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' NSU=' + @V_NRNSU_OLD;
         END;

         IF @V_NRACESSONFE_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' ChaveNFe=' + @V_NRACESSONFE_OLD;
         END;

         IF @V_NRINSJUREMIT_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' Ins.Emitente=' + @V_NRINSJUREMIT_OLD;
         END;

         IF @V_NMRAZSOCEMIT_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' RazSocEmitente=' + @V_NMRAZSOCEMIT_OLD;
         END;

         IF @V_CDINSCESTAEMIT_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' IEEmitente=' + @V_CDINSCESTAEMIT_OLD;
         END;

         IF @V_DTEMISSAO_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' DtEmiss=' + @V_DTEMISSAO_OLD;
         END;

         IF @V_NRNOTAFISC_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' NrEmiss=' + @V_NRNOTAFISC_OLD;
         END;

         IF @V_IDENTRSAIDNF_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' E/S=' + @V_IDENTRSAIDNF_OLD;
         END;

         IF @V_VRNOTAFISC_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' VrNota=' + @V_VRNOTAFISC_OLD;
         END;

         IF @V_CDDIGESTVALUE_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' DigestValue=' + @V_CDDIGESTVALUE_OLD;
         END;

         IF @V_DTRECBTO_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' Dt.Aut=' + @V_DTRECBTO_OLD;
         END;

         IF @V_IDSTATUSNFE_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' StatusNFe=' + @V_IDSTATUSNFE_OLD;
         END;

         IF @V_IDSTATUSMANIF_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' StatusManif=' + @V_IDSTATUSMANIF_OLD;
         END;

         IF @V_IDTIPOEVENTO_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' Evento=' + @V_IDTIPOEVENTO_OLD;
         END;

         IF @V_DTHREVENTO_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' DtEvento=' + @V_DTHREVENTO_OLD;
         END;

         IF @V_NRSEQEVENTO_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' SeqEvento=' + @V_NRSEQEVENTO_OLD;
         END;

         IF @V_DSCORRECAONFE_OLD  IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' DsCorrecao=' + @V_DSCORRECAONFE_OLD;
         END;

         IF @V_CDFILIAL_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' CdFilial=' + @V_CDFILIAL_OLD;
         END;

         IF @V_NRLANCTONF_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' NrLanc=' + @V_NRLANCTONF_OLD;
         END;

         IF @V_NRACESSOINTG_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' Intg=' + @V_NRACESSOINTG_OLD;
         END;

         IF @V_IDAMBIENTEMANIF_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' Amb=' + @V_IDAMBIENTEMANIF_OLD;
         END;

         IF @V_DSOBSSTATUSMANIF_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' ObsManif=' + @V_DSOBSSTATUSMANIF_OLD;
         END;

         IF @V_NRLOTEMANIF_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' LoteEven=' + @V_NRLOTEMANIF_OLD;
         END;

         IF @V_NRPROTOCOLO_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' Protocolo=' + @V_NRPROTOCOLO_OLD;
         END;

         IF @V_CDIBGEESTADOA_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' UFAut=' + @V_CDIBGEESTADOA_OLD;
         END;

         IF @V_IDASSINATURA_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' Ass=' + @V_IDASSINATURA_OLD;
         END;
      END
      ELSE
      IF @V_ID_COMANDO= 'U' /*UPDATING*/ BEGIN
         IF (@V_NRNFDESTINADA_NEW    <> @V_NRNFDESTINADA_OLD)   OR
            (@V_CDINSCESTA_NEW       <> @V_CDINSCESTA_OLD)      OR
            (@V_SGESTADO_NEW         <> @V_SGESTADO_OLD)     OR
            (@V_NRNSU_NEW            <> @V_NRNSU_OLD)  OR
            (@V_NRACESSONFE_NEW      <> @V_NRACESSONFE_OLD)   OR
            (@V_NRINSJUREMIT_NEW     <> @V_NRINSJUREMIT_OLD)    OR
            (@V_NMRAZSOCEMIT_NEW     <> @V_NMRAZSOCEMIT_OLD)   OR
            (@V_CDINSCESTAEMIT_NEW   <> @V_CDINSCESTAEMIT_OLD)   OR
            (@V_DTEMISSAO_NEW        <> @V_DTEMISSAO_OLD)   OR
            (@V_NRNOTAFISC_NEW       <> @V_NRNOTAFISC_OLD) OR
            (@V_IDENTRSAIDNF_NEW     <> @V_IDENTRSAIDNF_OLD)   OR
            (@V_VRNOTAFISC_NEW       <> @V_VRNOTAFISC_OLD)      OR
            (@V_CDDIGESTVALUE_NEW    <> @V_CDDIGESTVALUE_OLD)  OR
            (@V_DTRECBTO_NEW         <> @V_DTRECBTO_OLD)     OR
            (@V_IDSTATUSNFE_NEW      <> @V_IDSTATUSNFE_OLD)  OR
            (@V_IDSTATUSMANIF_NEW    <> @V_IDSTATUSMANIF_OLD)    OR
            (@V_IDTIPOEVENTO_NEW     <> @V_IDTIPOEVENTO_OLD) OR
            (@V_DTHREVENTO_NEW       <> @V_DTHREVENTO_OLD)  OR
            (@V_NRSEQEVENTO_NEW      <> @V_NRSEQEVENTO_OLD) OR
            (@V_DSCORRECAONFE_NEW    <> @V_DSCORRECAONFE_OLD) OR
            (@V_CDFILIAL_NEW         <> @V_CDFILIAL_OLD )  OR
            (@V_NRLANCTONF_NEW       <> @V_NRLANCTONF_OLD)   OR
            (@V_NRACESSOINTG_NEW     <> @V_NRACESSOINTG_OLD)   OR
            (@V_IDAMBIENTEMANIF_NEW  <> @V_IDAMBIENTEMANIF_OLD) OR
            (@V_DSOBSSTATUSMANIF_NEW <> @V_DSOBSSTATUSMANIF_OLD) OR
            (@V_NRLOTEMANIF_NEW      <> @V_NRLOTEMANIF_OLD)   OR
            (@V_NRPROTOCOLO_NEW      <> @V_NRPROTOCOLO_OLD)  OR
            (@V_CDIBGEESTADOA_NEW    <> @V_CDIBGEESTADOA_OLD)  OR
            (@V_IDASSINATURA_NEW     <> @V_IDASSINATURA_OLD)    OR
            (@V_NRDOWNLOADXML_NEW    <> @V_NRDOWNLOADXML_OLD) BEGIN

            SET @V_TIPO         = '2';
            SET @V_ITPESQ       = @V_NRNFDESTINADA_OLD;
         END;
      END
      ELSE BEGIN
         SET @V_TIPO   = '1';
         SET @V_ITPESQ = @V_NRNFDESTINADA_NEW;
      END;


      IF @V_CDINSCESTA_NEW IS NOT NULL BEGIN
         SET @V_DESC = @V_DESC + ' IE=' + @V_CDINSCESTA_NEW;
      END;

      IF @V_SGESTADO_NEW IS NOT NULL BEGIN
         SET @V_DESC = @V_DESC + ' UF=' + @V_SGESTADO_NEW;
      END;

      IF @V_NRNSU_NEW IS NOT NULL BEGIN
         SET @V_DESC = @V_DESC + ' NSU=' + @V_NRNSU_NEW;
      END;

      IF @V_NRACESSONFE_NEW IS NOT NULL BEGIN
         SET @V_DESC = @V_DESC + ' ChaveNFe=' + @V_NRACESSONFE_NEW;
      END;

      IF @V_NRINSJUREMIT_NEW IS NOT NULL BEGIN
         SET @V_DESC = @V_DESC + ' Ins.Emitente=' + @V_NRINSJUREMIT_NEW;
      END;

      IF @V_NMRAZSOCEMIT_NEW IS NOT NULL BEGIN
         SET @V_DESC = @V_DESC + ' RazSocEmitente=' + @V_NMRAZSOCEMIT_NEW;
      END;

      IF @V_CDINSCESTAEMIT_NEW IS NOT NULL BEGIN
         SET @V_DESC = @V_DESC + ' IEEmitente=' + @V_CDINSCESTAEMIT_NEW;
      END;

      IF @V_DTEMISSAO_NEW IS NOT NULL BEGIN
         SET @V_DESC = @V_DESC + ' DtEmiss=' + @V_DTEMISSAO_NEW;
      END;

      IF @V_NRNOTAFISC_NEW IS NOT NULL BEGIN
         SET @V_DESC = @V_DESC + ' NrEmiss=' + @V_NRNOTAFISC_NEW;
      END;

      IF @V_IDENTRSAIDNF_NEW IS NOT NULL BEGIN
         SET @V_DESC = @V_DESC + ' E/S=' + @V_IDENTRSAIDNF_NEW;
      END;

      IF @V_VRNOTAFISC_NEW IS NOT NULL BEGIN
         SET @V_DESC = @V_DESC + ' VrNota=' + @V_VRNOTAFISC_NEW;
      END;

      IF @V_CDDIGESTVALUE_NEW IS NOT NULL BEGIN
         SET @V_DESC = @V_DESC + ' DigestValue=' + @V_CDDIGESTVALUE_NEW;
      END;

      IF @V_DTRECBTO_NEW IS NOT NULL BEGIN
         SET @V_DESC = @V_DESC + ' Dt.Aut=' + @V_DTRECBTO_NEW;
      END;

      IF @V_IDSTATUSNFE_NEW IS NOT NULL BEGIN
         SET @V_DESC = @V_DESC + ' StatusNFe=' + @V_IDSTATUSNFE_NEW;
      END;

      IF @V_IDSTATUSMANIF_NEW IS NOT NULL BEGIN
         SET @V_DESC = @V_DESC + ' StatusManif=' + @V_IDSTATUSMANIF_NEW;
      END;

      IF @V_IDTIPOEVENTO_NEW IS NOT NULL BEGIN
         SET @V_DESC = @V_DESC + ' Evento=' + @V_IDTIPOEVENTO_NEW;
      END;

      IF @V_DTHREVENTO_NEW IS NOT NULL BEGIN
         SET @V_DESC = @V_DESC + ' DtEvento=' + @V_DTHREVENTO_OLD;
      END;

      IF @V_NRSEQEVENTO_OLD IS NOT NULL BEGIN
         SET @V_DESC = @V_DESC + ' SeqEvento=' + @V_NRSEQEVENTO_NEW;
      END;

      IF @V_DSCORRECAONFE_NEW  IS NOT NULL BEGIN
         SET @V_DESC = @V_DESC + ' DsCorrecao=' + @V_DSCORRECAONFE_NEW;
      END;

      IF @V_CDFILIAL_NEW IS NOT NULL BEGIN
         SET @V_DESC = @V_DESC + ' CdFilial=' + @V_CDFILIAL_NEW;
      END;

      IF @V_NRLANCTONF_NEW IS NOT NULL BEGIN
         SET @V_DESC = @V_DESC + ' NrLanc=' + @V_NRLANCTONF_NEW;
      END;

      IF @V_NRACESSOINTG_NEW IS NOT NULL BEGIN
         SET @V_DESC = @V_DESC + ' Intg=' + @V_NRACESSOINTG_NEW;
      END;

      IF @V_IDAMBIENTEMANIF_NEW IS NOT NULL BEGIN
         SET @V_DESC = @V_DESC + ' Amb=' + @V_IDAMBIENTEMANIF_NEW;
      END;

      IF @V_DSOBSSTATUSMANIF_NEW IS NOT NULL BEGIN
         SET @V_DESC = @V_DESC + ' ObsManif=' + @V_DSOBSSTATUSMANIF_NEW;
      END;

      IF @V_NRLOTEMANIF_NEW IS NOT NULL BEGIN
         SET @V_DESC = @V_DESC + ' LoteEven=' + @V_NRLOTEMANIF_NEW;
      END;

      IF @V_NRPROTOCOLO_NEW IS NOT NULL BEGIN
         SET @V_DESC = @V_DESC + ' Protocolo=' + @V_NRPROTOCOLO_NEW;
      END;

      IF @V_CDIBGEESTADOA_NEW IS NOT NULL BEGIN
         SET @V_DESC = @V_DESC + ' UFAut=' + @V_CDIBGEESTADOA_NEW;
      END;

      IF @V_IDASSINATURA_NEW IS NOT NULL BEGIN
         SET @V_DESC = @V_DESC + ' Ass=' + @V_IDASSINATURA_NEW;
      END;
      IF @V_TIPO <> '0' BEGIN
         IF NOT @V_DESC IS NULL BEGIN
            IF @V_USUARIO IS NOT NULL BEGIN
               SET  @V_DTOPER = GETDATE();
               SET @V_TAM = LEN(@V_DESC);
               WHILE (@V_TAM >= 0) BEGIN
                  INSERT INTO LOGOPERA
                     (NMTABELA,   DTOPERACAO, NMRESPOPER,
                      IDTIPOOPER, CDPESQITEM, DSOPERACAO)
                  VALUES
                     ('NOTADESTINADA', @V_DTOPER, @V_USUARIO,
                      @V_TIPO,    @V_ITPESQ, SUBSTRING(@V_DESC,1,600));
      
                   SET @V_DESC = SUBSTRING(@V_DESC, 600, @V_TAM);   
                   SET @V_TAM = LEN(@V_DESC);
               END;
            END;
         END;
      END;
      FETCH NEXT FROM C_CURSOR_ND INTO @V_ID_COMANDO,
                                    @V_NRNFDESTINADA_OLD,    @V_CDINSCESTA_OLD,      @V_SGESTADO_OLD,
                                    @V_NRNSU_OLD,            @V_NRACESSONFE_OLD,     @V_NRINSJUREMIT_OLD,
                                    @V_NMRAZSOCEMIT_OLD,     @V_CDINSCESTAEMIT_OLD,  @V_DTEMISSAO_OLD,
                                    @V_NRNOTAFISC_OLD,       @V_IDENTRSAIDNF_OLD,    @V_VRNOTAFISC_OLD,
                                    @V_CDDIGESTVALUE_OLD,    @V_DTRECBTO_OLD,        @V_IDSTATUSNFE_OLD,
                                    @V_IDSTATUSMANIF_OLD,    @V_IDTIPOEVENTO_OLD,    @V_DTHREVENTO_OLD,
                                    @V_NRSEQEVENTO_OLD,      @V_DSCORRECAONFE_OLD,   @V_CDFILIAL_OLD,
                                    @V_NRLANCTONF_OLD,       @V_NRACESSOINTG_OLD,    @V_IDAMBIENTEMANIF_OLD,
                                    @V_DSOBSSTATUSMANIF_OLD, @V_NRLOTEMANIF_OLD,     @V_NRPROTOCOLO_OLD,
                                    @V_CDIBGEESTADOA_OLD,    @V_IDASSINATURA_OLD,    @V_NRDOWNLOADXML_OLD,

                                    @V_NRNFDESTINADA_NEW,    @V_CDINSCESTA_NEW,     @V_SGESTADO_NEW,
                                    @V_NRNSU_NEW,            @V_NRACESSONFE_NEW,    @V_NRINSJUREMIT_NEW,
                                    @V_NMRAZSOCEMIT_NEW,     @V_CDINSCESTAEMIT_NEW, @V_DTEMISSAO_NEW,
                                    @V_NRNOTAFISC_NEW,       @V_IDENTRSAIDNF_NEW,   @V_VRNOTAFISC_NEW,
                                    @V_CDDIGESTVALUE_NEW,    @V_DTRECBTO_NEW,       @V_IDSTATUSNFE_NEW,
                                    @V_IDSTATUSMANIF_NEW,    @V_IDTIPOEVENTO_NEW,   @V_DTHREVENTO_NEW,
                                    @V_NRSEQEVENTO_NEW,      @V_DSCORRECAONFE_NEW,  @V_CDFILIAL_NEW,
                                    @V_NRLANCTONF_NEW,       @V_NRACESSOINTG_NEW,   @V_IDAMBIENTEMANIF_NEW,
                                    @V_DSOBSSTATUSMANIF_NEW, @V_NRLOTEMANIF_NEW,    @V_NRPROTOCOLO_NEW,
                                    @V_CDIBGEESTADOA_NEW,    @V_IDASSINATURA_NEW,   @V_NRDOWNLOADXML_NEW;
   END;
   CLOSE      C_CURSOR_ND;
   DEALLOCATE C_CURSOR_ND;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'LOG_FIS_NOTADESTINADA','6.05.xxx';
GO

